package net.chlup.myshare;

import android.preference.PreferenceManager;
import android.content.Context;
import android.content.SharedPreferences;

public class Preferences {
	Context ctx;

	/* The preference values */
	public String target_url;
	public String http_user;
	public String http_password;
	public boolean own_key_store;

	Preferences(Context ctx) {
		this.ctx = ctx;
	}

	public void load() {

		SharedPreferences prefs = PreferenceManager
				.getDefaultSharedPreferences(this.ctx);

		this.target_url = prefs.getString("target_url", null);

		this.http_user = prefs.getString("http_user", null);
		if (this.http_user == null || this.http_user.length() < 1)
			this.http_user = null;

		this.http_password = prefs.getString("http_password", null);
		if (this.http_password == null || this.http_password.length() < 1)
			this.http_password = null;

		this.own_key_store = prefs.getBoolean("own_key_store", false);
		
	}
}
