package net.chlup.myshare;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.security.KeyManagementException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.UnrecoverableKeyException;
import java.security.cert.CertificateException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.client.DefaultHttpRequestRetryHandler;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import android.app.Activity;
import android.content.ContentResolver;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.util.Base64;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;

public class myshare extends Activity {
	
    /* Prefs */
    Preferences prefs;
	URL target_url;
    
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState)	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		/* Get prefs */
		this.prefs = new Preferences(this);
		this.prefs.load();
		
		/* Set URL */
		this.target_url = null;
		try {
		    this.target_url = new URL(this.prefs.target_url);
		}
		catch (MalformedURLException e) {
			Log.e(this.getClass().getName(), e.toString());
		    this.target_url = null;
		}
		
	}

	@Override
	protected void onStart()	{
		super.onStart();
		
		TextView main_result = (TextView) findViewById(R.id.main_result);
		
		Intent intent = getIntent();
		Bundle extras = intent.getExtras();
		String action = intent.getAction();

		// if this is from the share menu
		if (
				Intent.ACTION_SEND.equals(action)
				&& this.target_url != null
	    ) {
			if (extras.containsKey(Intent.EXTRA_STREAM)) {
				Log.i(this.getClass().getName(), "nazdar");
				try	{
					// Get resource path from intent callee
					Uri uri = (Uri) extras.getParcelable(Intent.EXTRA_STREAM);

					// Query gallery for camera picture via
					// Android ContentResolver interface
					ContentResolver cr = getContentResolver();
					InputStream is = cr.openInputStream(uri);
					// Get binary bytes for encode
					byte[] data = getBytesFromFile(is);

					String data_string = Base64.encodeToString(data,Base64.NO_WRAP);

					String result = SendRequest(data_string);
					
					main_result.setText(result);
					
					return;
				}
				catch (Exception e)	{
					Log.e(this.getClass().getName(), e.toString());
				}

			}
			else if (extras.containsKey(Intent.EXTRA_TEXT))	{
				return;
			}
		}

	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		menu.add(0, 100, 100, R.string.mainSettings).setIcon(
				android.R.drawable.ic_menu_preferences);
		return true;
	}
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case 100:
			Intent prefA = new Intent(this, PreferencesActivity.class);
			startActivityForResult(prefA, 0);
			break;
		}

		return true;
	}
	@Override
	public void onActivityResult(int req, int res, Intent i) {
		this.prefs.load();
	}

	private String SendRequest(String data_string) {
		String result = "";

	    DefaultHttpClient httpclient;
    	httpclient = new DefaultHttpClient();
    	httpclient.setHttpRequestRetryHandler(new DefaultHttpRequestRetryHandler(1, false)); // retry jen 1x (napriklad je nedostupna sit) (pokud bych to neuvedl, tak defaultne je tusim retry 3x)
    	
    	if(this.prefs.own_key_store) {
			try {
				KeyStore trustStore = KeyStore.getInstance(KeyStore.getDefaultType());
				FileInputStream instream = new FileInputStream(new File("/sdcard/security/cacerts.bks"));
                trustStore.load(instream, "changeit".toCharArray());
                instream.close();
                SSLSocketFactory socketFactory = new SSLSocketFactory(trustStore);
                Scheme sch = new Scheme("https", socketFactory, 443);
                httpclient.getConnectionManager().getSchemeRegistry().register(sch);
			}
			catch (KeyStoreException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			catch (NoSuchAlgorithmException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			catch (CertificateException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			catch (KeyManagementException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			catch (UnrecoverableKeyException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 
    	}
    	
    	List<NameValuePair> nameValuePairs;
    	nameValuePairs = new ArrayList<NameValuePair>(2);
    	nameValuePairs.add(new BasicNameValuePair("img", data_string));		    	

		HttpPost httppost = new HttpPost(target_url.toString());
		if (this.prefs.http_user != null && this.prefs.http_password != null) {
			String http_userpassword = this.prefs.http_user + ":" + this.prefs.http_password; 
			httppost.setHeader("Authorization", "basic " + Base64.encodeToString(http_userpassword.getBytes(),Base64.NO_WRAP));
		}

		HttpResponse response;
		
		try {
			String serverinfo="";
			httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
			response = httpclient.execute(httppost);
			HttpEntity entity = response.getEntity();
			if (entity != null) {
				serverinfo=EntityUtils.toString(entity); // tohle muze asi pripadne nahradit radek nize (pokud budes chti s obsahem co je vracen pracovat)
				if(serverinfo.length()>100) {
					serverinfo=serverinfo.substring(0,100);
				}
				//entity.consumeContent(); // zajisti asi konzumaci obsahu s ukoncenim pozadavku - diky tomu funguje keep-alive (kdyz to tu nebylo, keep-alive nefungoval - nestacilo jen posunout definic httpclient nahoru)
		    }
			result = myshare.this.getString(R.string.msgUploadedSuccessfully) +
						"\nSERVER: "+serverinfo;
		}
		catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
		}
		catch (IOException e) {
			result = myshare.this.getString(R.string.msgUploadFailed);
		}
		return result;
	}

	public static byte[] getBytesFromFile(InputStream is) {
		try {
			ByteArrayOutputStream buffer = new ByteArrayOutputStream();

			int nRead;
			byte[] data = new byte[16384];

			while ((nRead = is.read(data, 0, data.length)) != -1) {
				buffer.write(data, 0, nRead);
			}

			buffer.flush();

			return buffer.toByteArray();
		}
		catch (IOException e) {
			Log.e("chlup.net.myshare.myshare", e.toString());
			return null;
		}
	}

}
